;========================================================================================
; Description:      Chip-IT
; Author(s):        MrBond007 (Baki G)
; Comments:			A Very Useless ChipTunes Player :)
;
;					Remember if you like AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;========================================================================================
If Not FileExists("bassmod.dll") Then
	MsgBox(0, "Error : BASSMOD.DLL not found", "Get the file from : 'http://www.un4seen.com/bassmod.html'")
	Exit
EndIf

Local $bassdll, $n = 0, $c = 0, $x = 0, $Gui_h, $State
local $Labels[9], $Buttons[7], $Sliders[3], $H_Music = -1, $Name_H, $pAth

Global Const $BASS_DEVICE_8BITS = 1
Global Const $BASS_DEVICE_MONO = 2
Global Const $BASS_DEVICE_NOSYNC = 16

Global Const $BASS_MUSIC_RAMP = 1
Global Const $BASS_MUSIC_RAMPS = 2
Global Const $BASS_MUSIC_LOOP = 4
Global Const $BASS_MUSIC_FT2MOD = 16
Global Const $BASS_MUSIC_PT1MOD = 32
Global Const $BASS_MUSIC_POSRESET = 256
Global Const $BASS_MUSIC_SURROUND = 512
Global Const $BASS_MUSIC_SURROUND2 = 1024
Global Const $BASS_MUSIC_STOPBACK = 2048
Global Const $BASS_MUSIC_CALCLEN = 8192
Global Const $BASS_MUSIC_NONINTER = 16384

Global Const $BASS_ACTIVE_STOPPED = 0
Global Const $BASS_ACTIVE_PLAYING = 1
Global Const $BASS_ACTIVE_PAUSED = 3

#include <GUIConstants.au3>
#NoTrayIcon
Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

$GUI = GUICreate("Chip-IT", 231, 245, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetOnEvent(-3, "Close")
GUISetOnEvent(-5, "Restore")
GUISetBkColor(0xFFFFFF)
GUICtrlCreatePic("1.jpg", 0, 0, 200, 80)
GUICtrlSetState(-1, $GUI_DISABLE)
$Gui_h = WinGetHandle($GUI, "")

_PictureData()

GUICtrlCreatePic(@TempDir & "\chip.jpg", 0, 0, 95, 44)
$buttons[0] = GUICtrlCreatePic(@TempDir & "\1.jpg", 165, 5, 36, 31)
GUICtrlSetOnEvent($buttons[0], "Mini")
$buttons[1] = GUICtrlCreatePic(@TempDir & "\2.jpg", 195, 2, 36, 42)
GUICtrlSetOnEvent($buttons[1], "Close")
$buttons[2] = GUICtrlCreatePic(@TempDir & "\3.jpg", 135, 0, 34, 39)
GUICtrlSetOnEvent($buttons[2], "_MsgBx")
$buttons[3] = GUICtrlCreateButton(">", 10, 50, 25, 25)
GUICtrlSetOnEvent($buttons[3], "_PlayChip")
$buttons[4] = GUICtrlCreateButton("||", 50, 50, 25, 25)
GUICtrlSetOnEvent($buttons[4], "_PauseChip")
$buttons[5] = GUICtrlCreateButton("[]", 90, 50, 25, 25)
GUICtrlSetOnEvent($buttons[5], "_StopChip")
$buttons[6] = GUICtrlCreateButton("...", 197, 50, 25, 25)
GUICtrlSetOnEvent($buttons[6], "_ChooseChip")

For $i = 0 To UBound($Buttons)-1
	GUICtrlSetCursor($Buttons[$i], 0)
Next

FileDelete(@TempDir & "\chip.jpg")
FileDelete(@TempDir & "\1.jpg")
FileDelete(@TempDir & "\2.jpg")
FileDelete(@TempDir & "\3.jpg")

$Labels[0] = GUICtrlCreateLabel("Song Lenght", 10, 87, 65, 20)
$Labels[1] = GUICtrlCreateLabel("000:000", 182, 87, 40, 20)
$Labels[2] = GUICtrlCreateLabel("Current Position", 10, 110, 75, 20)
$Labels[3] = GUICtrlCreateLabel("000:000", 182, 110, 40, 20)
$Labels[4] = GUICtrlCreateLabel("Plugin CPU Usage", 10, 133, 90, 20)
$Labels[5] = GUICtrlCreateLabel("0%", 182, 133, 35, 20)
$Labels[6] = GUICtrlCreateLabel("AutoIt = The sky is the limit, " _
			& @CRLF & "Chip-It is brought to you by mrbond007"  _
			& @CRLF & "Hope you like it :)", 10, 250, 190, 40)
$Labels[7] = GUICtrlCreateLabel("Amplify", 10, 190, 50, 20)
$Labels[8] = GUICtrlCreateLabel("Volume", 10, 220, 50, 20)
GUICtrlSetResizing($Labels[7], $GUI_DOCKALL)
GUICtrlSetResizing($Labels[8], $GUI_DOCKALL)

For $i = 0 To UBound($Buttons)-1
	GUICtrlSetResizing($Labels[$i], $GUI_DOCKALL)
	GUICtrlSetResizing($Buttons[$i], $GUI_DOCKALL)
Next

$Sliders[0] = GUICtrlCreateSlider(0, 157, 230, 25, $TBS_NOTICKS)
$Sliders[1] = GUICtrlCreateSlider(135, 185, 95, 25, $TBS_NOTICKS)
$Sliders[2] = GUICtrlCreateSlider(135, 215, 95, 25, $TBS_NOTICKS)

For $i = 0 To UBound($Sliders)-1
	GUICtrlSetOnEvent($Sliders[$i], "_SlidersPos")
	GUICtrlSetData($Sliders[$i], 0)
	GUICtrlSetBkColor($Sliders[$i], 0xFFFFFF)
	GUICtrlSetResizing($Sliders[$i], $GUI_DOCKALL)
	If $i > 0 Then
		GUICtrlSetLimit($Sliders[$i], 100)
		GUICtrlSetData($Sliders[$i], 50)
	EndIf
Next

GUIRegisterMsg(0x0084, "WM_NCHITTEST")
$bassdll = DllOpen("BASSMOD.dll")
$Init = DllCall($bassdll, "int", "BASSMOD_Init", "int", -1, _
		"int", 44100, _
		"int", 0)
GUIEffect($GUI, 1)
GUISetState()

While 1
	Sleep(100)
WEnd

Func WM_NCHITTEST($hWnd, $iMsg, $iwParam, $ilParam)
	If ($hWnd = $GUI) And ($iMsg = 0x0084) Then Return 2
EndFunc

Func _ChooseChip()
	$pAth = FileOpenDialog("Chips ??", "", "(*.xm;*.mod;*.s3m;*.it;*.mtm;*.mo3)")
	If Not ($pAth = "") Then
		$M_Active = DllCall($bassdll, "int", "BASSMOD_MusicIsActive")
		If $M_Active[0] = $BASS_ACTIVE_STOPPED Or _
				$M_Active[0] = $BASS_ACTIVE_PLAYING Or _
				$M_Active[0] = $BASS_ACTIVE_PAUSED Then _
				DllCall($bassdll, "int:cdecl", "BASSMOD_MusicFree", "int", $H_Music)
		$Name_H = DllStructCreate("char[255]")
		DllStructSetData($Name_H, 1, $pAth)
		$Init = DllCall($bassdll, "int", "BASSMOD_MusicLoad", "int", 0, _
				"ptr", DllStructGetPtr($Name_H), _
				"int", 0, _
				"int", 0, _
				"int", BitOR($BASS_MUSIC_LOOP, $BASS_MUSIC_SURROUND2, $BASS_MUSIC_CALCLEN))
		$H_Music = $Init[0]
		$Name_H = 0
		AdlibDisable()
		$len_h = DllCall($bassdll, "int", "BASSMOD_MusicGetLength", "int", False)
		If StringLen($len_h[0]) > 2 Then
			GUICtrlSetData($Labels[1], $len_h[0] & ":000")
		ElseIf StringLen($len_h[0]) = 2 Then
			GUICtrlSetData($Labels[1], "0" & $len_h[0] & ":000")
		Else
			GUICtrlSetData($Labels[1], "00" & $len_h[0] & ":000")
		EndIf
		GUICtrlSetData($Labels[3], "000:000")
		GUICtrlSetData($Labels[5], "0%")
		GUICtrlSetData($Sliders[0], 0)
		GUICtrlSetLimit($Sliders[0], $len_h[0])
	EndIf
EndFunc

Func _PlayChip()
	If $Init[0] <> "" And $pAth <> "" Then
		$Name_H = DllStructCreate("char[255]")
		DllStructSetData($Name_H, 1, $pAth)
		DllCall($bassdll, "int", "BASSMOD_MusicLoad", "int", 0, _
				"ptr", DllStructGetPtr($Name_H), _
				"int", 0, _
				"int", 0, _
				"int", BitOR($BASS_MUSIC_LOOP, $BASS_MUSIC_SURROUND2))
	EndIf
	DllCall($bassdll, "int:cdecl", "BASSMOD_MusicPlay", "int", $H_Music)
	AdlibEnable("_Resources", 250)
EndFunc

Func _Resources()
	$c += 1
	$Get_Pos = DllCall($bassdll, "int", "BASSMOD_MusicGetPosition")
	$Format_Out = StringFormat("%03d.%03d", BitAND($Get_Pos[0], 0xFFFF), BitShift($Get_Pos[0], 16))
	GUICtrlSetData($Labels[3], $Format_Out)
	$Get_Cpu = DllCall($bassdll, "float", "BASSMOD_GetCPU")
	GUICtrlSetData($Labels[5], StringFormat("%.2f%%", $Get_Cpu[0]))
	If $c = 4 Then
		$c = 0
		GUICtrlSetData($Sliders[0], BitAND($Get_Pos[0], 0xFFFF))
	EndIf
EndFunc

Func _SlidersPos()
	Select
		Case @GUI_CtrlHandle = ControlGetHandle($GUI, "", $Sliders[0])
			_GetMusictate()
			If $State = 1 Then DllCall($bassdll, "int", "BASSMOD_MusicSetPosition", "int", GUICtrlRead($Sliders[0]))
		Case @GUI_CtrlHandle = ControlGetHandle($GUI, "", $Sliders[1])
			_GetMusictate()
			If $State = 1 Then DllCall($bassdll, "int", "BASSMOD_MusicSetAmplify", "int", GUICtrlRead($Sliders[1]))
		Case @GUI_CtrlHandle = ControlGetHandle($GUI, "", $Sliders[2])
			DllCall($bassdll, "int", "BASSMOD_SetVolume", "int", GUICtrlRead($Sliders[2]))
	EndSelect
	GUICtrlSetState($Labels[6], $GUI_FOCUS)
EndFunc

Func _GetMusictate()
	$M_Active = DllCall($bassdll, "int", "BASSMOD_MusicIsActive")
	If $M_Active[0] = $BASS_ACTIVE_PLAYING Or $M_Active[0] = $BASS_ACTIVE_PAUSED Then
		$State = 1
	Else
		$State = 0
	EndIf
EndFunc

Func _PauseChip()
	AdlibDisable()
	DllCall($bassdll, "int:cdecl", "BASSMOD_MusicPause", "int", $H_Music)
EndFunc

Func _StopChip()
	AdlibDisable()
	GUICtrlSetData($Labels[3], "000:000")
	GUICtrlSetData($Labels[5], "0%")
	GUICtrlSetData($Sliders[0], 0)
	DllCall($bassdll, "int:cdecl", "BASSMOD_MusicStop", "int", $H_Music)
	DllCall($bassdll, "int:cdecl", "BASSMOD_MusicFree", "int", $H_Music)
EndFunc

Func _MsgBx()
	$n += 1
	$GuiPos = WinGetPos($Gui_h, "")
	If $n = 1 Then
		WinMove($Gui_h, "", $GuiPos[0], $GuiPos[1], $GuiPos[2], $GuiPos[3]+55)
		$x = -100
		For $i = 1 To 22
			$x += 5
			ControlMove($Gui_h, "", $Labels[6], $x, 250)
			Sleep(10)
		Next
	ElseIf $n = 2 Then
		$n = 0
		$x = 10
		For $i = 1 To 22
			$x -= 5
			ControlMove($Gui_h, "", $Labels[6], $x, 250)
			Sleep(10)
		Next
		WinMove($Gui_h, "", $GuiPos[0], $GuiPos[1], $GuiPos[2], $GuiPos[3]-55)
	EndIf
EndFunc

Func GUIEffect($hWnd, $Effect)
	If $Effect = 1 Then
		DllCall("user32.dll", "int", "AnimateWindow", "hwnd", $hWnd, "int", 750, "long", 0x00080000)
	Else
		DllCall("user32.dll", "int", "AnimateWindow", "hwnd", $hWnd, "int", 750, "long", 0x00090000)
	EndIf
EndFunc

Func Mini()
	GUISetState(@SW_MINIMIZE)
	AdlibDisable()
EndFunc

Func Restore()
	_GetMusictate()
	If $State = 1 Then
		GUICtrlSetState($Labels[6], $GUI_FOCUS)
		AdlibEnable("_Resources", 250)
	EndIf
EndFunc

Func Close()
	GUIEffect($GUI, 0)
	Exit
EndFunc

Func OnAutoItExit()
	If FileExists("BASSMOD.DLL") Then
		DllCall($bassdll, "int:cdecl", "BASSMOD_MusicFree", "int", $H_Music)
		DllClose($bassdll)
	EndIf
EndFunc

Func _PictureData()
	Local $pic = "0x", $pic1 = "0x", $pic2 = "0x", $pic3 = "0x"
	$pic &= "FFD8FFE000104A46494600010101006000600000FFDB0043000101010101010101010101010101010101010"
	$pic &= "1010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101"
	$pic &= "FFDB004301010101010101010101010101010101010101010101010101010101010101010101010101010101010"
	$pic &= "10101010101010101010101010101010101010101010101FFC0001108002C005F03012200021101031101FFC400"
	$pic &= "1E00000103050101000000000000000000000906070A00010405080203FFC4003A1000010401020206070605050"
	$pic &= "00000000004010203050607110008091213142131154151617191F01632526281C1172253B1D123547292F1FFC4"
	$pic &= "001B01000105010100000000000000000000000603040507080209FFC4002A11000300020201040201030500000"
	$pic &= "000000102030405111213000607211431081522232425334161FFDA000C03010002110311003F009FC71A5B2B81"
	$pic &= "C06EF248D6F9F8AAEDF3F77D7AB7E326C8B41477BD576EAB55577F86FF005E3FDB8059D201CF8E4FA7FAAD8DF2D"
	$pic &= "7A473C75FA89798B8FA8D98E5C5C4190CC3B4E56F8DA48DB8E076429F51639D6466545B0B4D1DE08553D30C1CB6"
	$pic &= "C7555DC6F881E07BDD5EE8D37B37479BEE2DF643636B70150D5A727BDAB5B51630C7C78CC16ADEF6749CD7E9416"
	$pic &= "EF479CD5DD65F45A3D8FB8F698DA8D5456D9994CC103BACA6893534AD6B472152529AB3BB7D9E07545672AA4CDB"
	$pic &= "B3AAE6C9D9A90CDF7DBEF37DA89F8FDFFE78DE0D94033351527678A6FB23D3C3DDF79388E4DD73152CD5167363F"
	$pic &= "ACBCD732FBD1C5BE966B88795D229D96683BD407DA400E80085115A84A44A6C211431528DDA30622199D1C8D415"
	$pic &= "EF4886B9E199960BA720D961198B73B0A9CA76A14B84E4B8CCD86B2AE00E5D4369DA74DCFAEA1CAE58E435B161A"
	$pic &= "E875070C696E8C965940F41219ACEA89FF23BE3125FCFB0CEC4449B38A5F160EB57E94648497132F26AD5A99945"
	$pic &= "266B147792DAD2F2CCB1DBFC3DEF5013C58B8B90CCE10A4AF556452D356AB9C8C784C4E7E40CC039A32AB99CE9D"
	$pic &= "18094136F837377EDD9E5E1FCCCDBCBC9775DF7F6FF007E3447E655E33FAAE2234DBC3EF37F67227ABDBC009D3E"
	$pic &= "E79355F22CE33DC16DF32D23A2AAC51A15A639A8991D46A1D22669456F39628224B81D1499B3F1DBCAC7569735A"
	$pic &= "91366870870E556CE1D6D7F6F30F033587F393AB1A9B94E5B71A8B97E6B80E1C29A5D160F45A104E9CD94C5CD8E"
	$pic &= "DA1B51777F925C6B0693E4E7D932F0C0E6368A0ABAFC55B574ED1613EBEC8B9A4B157393FC87F8B71F1F12E9BBB"
	$pic &= "65D72ED48261E261D1F2254803F93E77A34B1273C7A75835FF29A16ABA0C5A6421EE1087C49EF7B5AF26D6CF1D2"
	$pic &= "134AB6464642A4A89523C3E2540F90EF5426A25E0159CD58DD24C3A992D57E620192A3193B1CABE09B393F2FE65"
	$pic &= "F6FD78F0B36170B988EEBB7C537F34FF3C45CB36E7D329E5DEE68F5146CAB54350B486A62959AB147AA83697B72"
	$pic &= "9ABAB2091621728D392B4BB4FB026927D2A2CC4DB51646CB31AEABD928E0114C5B7D251120D66E903C3744744F2"
	$pic &= "AD63B779575498CD0C16D0014EAD90FBD2ACC916BA86AEB95EF6C6935D5AD8D7003CF27FA50A9693488AC63914C"
	$pic &= "3DA3F26FB47DEB81B9D869F39D63A06FF765CC98853124718E52E5378E9695315E296EB68D68A1E179B057995F4"
	$pic &= "3FBFF0065EFFDB795AEC4D8632B536C3FD0363B9AA6453CC20623B2CDD2CB479F33A221EB5938E55C1F4574CB91"
	$pic &= "06639CB2B536DFCDC88BF14F1DFEBDFC2464CE6B9B2F67DE23F3DB6EB377F3FF0097ABE5F3F08F7EBE748E6B363"
	$pic &= "FA2D539E6186689D96619B938A51D761F15B6A5946E9E9F9C4E28435BDD986E15575B998989946322B402B971D9"
	$pic &= "2D158A4853318CEE736BAA39937AD5D44B91EB1F362B91C95C2BEDD2AA3E56A1AD7DB3478BD27E8A80BE5FA725A"
	$pic &= "034C591058C8988223816161134B2F59EE0DCEFE44FC5D8969C63B8BEC8D20B9069838BFE292504DA4B4A66D70C"
	$pic &= "792A945759CFC8CA3B2D44DD4A022C6F88BDEF79BD29AF96185AB482655FFC94642CB4645C69E4FF00623295676"
	$pic &= "EAA4F050B2B063247ACBD18F46F67235DBA2793917D9EC55DBEBDDC287CF8045D1B9CECE6BACF996AE68CEA5234"
	$pic &= "CCCF47AC71C2C6CAA18A11BED76139C7A7A5C5CCB708106BAAC2CB2ABD007D564DE89080A5B02A286CA9ABC310A"
	$pic &= "51603A81CBDA8F1BFD6AD4DF8B57DB5EE2D57BB745ADF71692ED91ACDAE3FE462D1E6D2A001DE559D66DF6958DA"
	$pic &= "748D57960288DD59D78620BB9D4676876999A8D94D659B835F15D15C5139645A4DD1D7E9A7493A510F009571D95"
	$pic &= "5B9509ACA6456033EDF85FB7FD5DEEFD7F4E222FCFB3D5DD27AC4FF0071CA6E1CE7AA78755D1EA96AEC6D4DFC15"
	$pic &= "1DD54454F77C13697864623880E66B537DDAEF9AA2EDEA55FF00C5F1E22ADD211A559451F480E3BA976A2482615"
	$pic &= "99E8251E9DE2F74B14B20F639ED16799CDC1B883656224505B974F9285675504EE492D6286C220639E60496B29F"
	$pic &= "FE4BC2D7F897722327A996CB436A745244E49B6C5EF573C7F6A2723B31FA0481FF007EAC2F862B397BFB5C69459"
	$pic &= "87C3DA4D7B103BBB60DBAA2F3FB66E09007D900F1E87DE5BCD3E7D886B25072E60D260666339C93465CB95D963E"
	$pic &= "F2338C7C122BF2C2AE29AA2DFBDC60F74B3928ABFA93175961635D011643D7183C8405E8CE8C9309A6B7B5A8CA4"
	$pic &= "C8C996E689960354111123435E221AF8A4290F1E5AA98C26570F1A443A8B641C10CAF7484C652A44AC7C26D1EC8"
	$pic &= "EBF16BB82CB4371990B35E2DC58E737DA6821798D3CB4B0CFDC4EAFCECB865BCC7C4A5188395A3D54E05520E65B"
	$pic &= "77D1668AD2D5C5F3B66A067988EACE99E1125A97521E675863ECB148EE488C7BE20DEE67E18F32AC035E0DA4B60"
	$pic &= "4219F67642A225EC2213DD1A04E85D2F1E776D7033249AC6CAD7EC2A90D76362D16D8B9204F30E7ECB264E17207"
	$pic &= "45098D5C791A270D34C3A5517AE3A9F5AE7072B1A8D99F8F958937AE65AE8676892F8FF0089851752D12589369D"
	$pic &= "5FA30E1DB25158F343EB1AA24466A264D02AA2B998CE2723E5491CD63D127BD62B118D635FD54D9FDB39AF7239B"
	$pic &= "23588D4D955F93A58D7CB4DDA8E4C82B9722CACB854490494D8DC993D8CF1C713EC6ACFAB92463376CCDB3A9280"
	$pic &= "9157B136BE689D388AE0E27A557F6BAB5A838D47698B56DEE358FE2B0DD55DD649534E5D74CA55FB2316661F3C7"
	$pic &= "1BE69236C2448D19F336210C165497B49118C6C87A0C8ABF48B52728C6EE2057E1F9066159265149653361AACB0"
	$pic &= "BC86C8AA7102B615F092E3C8954292BCDADED207CC5852466C492365E2165ACDA633C7269AECC592D77C471175A"
	$pic &= "16C4C99D32151CF0CB4824AB47520740AECFC2C89120F9B8565A4532F1D9D935439F2295E3222522587DA94AB3A"
	$pic &= "2A907EC90ABC9700B877589E379710DABD41C6DB9CE136A6B64BCC48EBA329BED0574C85CE94C7DA63B1D498189"
	$pic &= "3BA48185A5036AE550622A1AD75623E096143F37D5D89E65CB5E7D478FE026E085D10E7662CB68F57F5A326AF75"
	$pic &= "4615393950B8F9D8EE73A857B8E4D571435A0C45992852C95E958EB5AC1832201E08C83E8468273119E60BA3BA8"
	$pic &= "5AAFA8F9B576ACD669FD43ACE21B1BD2EAF8A8ADF21A105D95D5CB4DFC38756CA438B8E280A71E29A500400B156"
	$pic &= "1634339A86351D203CBAEBF9FCB0EA503519CE7D9DCD5F1555FAE2E941A6E2C9695C06455C4E483A498BE9F50DD"
	$pic &= "111331A75E4E95E35946D33A8824AC9C77A8CFD5B0F823E41D16976F9B879B18E3DF0ADB1ACD3175CD9F7C69E12"
	$pic &= "5698F7B50DB618794C13260B8D8472D025508715CBCBC785194F947DA5B3D96BF1B231AB4ACB267888EF6CB18B2"
	$pic &= "B36499ADA534F1E264414B4AAD6C8F03169B0EA5218F6A8C7E656F8DC7F41AAACEAA551AC9975A78A0588F33E5F"
	$pic &= "461AB774C80D8F69128EAE883316099D24728EF6A35CF6C9D6ECDBC29F4E75832CCCB412BF57ACA2AC6E56987CD"
	$pic &= "67009595E20D58C36B4289A2C03D4F762079079640E259E13233A73D92C8E36638A26622455F331A199A643CB18"
	$pic &= "226392E2F90D866F1E15578C525164D4F6973646DBCA2F778E1AB12794A4ECA264A518F58FAA20B04E44CAD8E27"
	$pic &= "AA63685E8AE600F27D1116E463B8F1B8A6276F4790D05E64551579055DCD244F02DAAEC294A223B21EC462637C1"
	$pic &= "DD16059A591FD458D55CC5E332FF0041DC4FDBD3B4F4FB019233322AD9139DD55F1A5A2D75E3121009878B79326"
	$pic &= "54EC6C05D8CC2AFDB5D2369AE6DB34DF63886271A28B2679315B536B952A382C4BF5A0F1C68BC0913301893FA30"
	$pic &= "5D139868A6E9BE33AD161DD8ECEB5BF19C4738CC6DC7892085DDEA9BBE5263B5E3F693A81478A0D684D75657290"
	$pic &= "4BC57CA6BA426692791FC4846BD9D41224FCA9ECFDB80C5D14FA3D98E97F2B1A0D8D66D4C4D164D59A7F4FE97A8"
	$pic &= "3237C4656926B65B06866C1231928C70F097146609335938853661A6632589ED69A215AAC8236AFA9138F5CFDA5"
	$pic &= "AEC4D4FB6341AFC1C29EBB1B1B5382A98539F8841DF1D2B70E842B1B3DDE94BBD0796B77A52A4D1DC9C03BECBBE"
	$pic &= "7EEB6B979392F996B67E496C977EE6AAB5649156E4813592A24954F4492A24F845503E92C6D958E63911515153C"
	$pic &= "7DFF5F3DB8E62D6BD0FC6B542A49A5C928EBEF2B4896021C2580B193130B0C861609B07688AF14FAF32284DAE3C"
	$pic &= "67446579B0406073C24C314ADEA1E3C3A363FC1CD477C789DACA579D2369CED1AA34EB2AA2D2749B82AF3A4DC15"
	$pic &= "74752559581560482083EA2D1DE4E949BB4E936574A231474752195D19486565201560410402083E85B58727F58"
	$pic &= "6C52D790974457CF1F772059F23C86788919C8D64901292DABD4986666F1931CEB23098DEF8C849639646BF22B3"
	$pic &= "922D34029CCA11B4F30D1696C5C1BEC69E0C62921AA3E4AF585C0C86D7C4134429E13871DC23E786470CB042B0A"
	$pic &= "B1638D509DF741FF00A69C7A41A144DBA89F2E2331F41A2C4677C4D26A315E926851F1F5B870678BAB2BC5DA515"
	$pic &= "2D26566569B128CACC08209E5EDB6BB4C8555BECB3EEA8E2A8B6CCC8A2AD1482B450F460AEA554871C3020107E8"
	$pic &= "7A1C75DC9EE0B5A136B40C331B0EB584CE632BC4A3AB18261852AB89298242332069043BF9A79D234965778C8E7"
	$pic &= "2F8F1B40B940D3BFB4A265456098991918930930F7E463B513DD0F204C4883921B590471D13C48956219D190D74"
	$pic &= "11AAB2256B576E084F7787FA6DF9717482145DD236A2F0F3F0307C7297E16278A262D19FE347C726C6E3F1DA49D"
	$pic &= "3ACCE3F03C250032E078FAF03D37FCACAEEF4FC9BF7A8A0A3F9A9DE82DFF3076EDCB8AF27C81890FCFF00773E9B"
	$pic &= "4C6B01AEAC1191F778F76B5136EAA6DE4BEFF3F1F6F157BA7F5B611B9AA346A8A9EB6EFF00BEDEBF3E1CF44444D"
	$pic &= "91364E2FC3BF487AE3C3F977C67BF1278B455839A5ABD4932000584A256491B2BD482238DB2CAAF7A23DFDA3DCA"
	$pic &= "E7B51EEDD51178F8D5F2ED8CC1690DAC943572D88EADEC4F90015E645D4D919D994E8D678FAA8AE46F5644DBACE"
	$pic &= "4454DD77EC6ECE3FC29C52451A2EE8C6A2FC384FC52E02F8A7D43770BD1780FFBEE071C06E7EFB7EFFF007D77E4"
	$pic &= "7E79EEFC95EA4F63CF5FD75E79E7AF1F5C7EBD2131AC547A8631B1C4D6EC89E49B796DF1FD3F4DB7E17A888D444"
	$pic &= "4F244DB8BEC89E49B715C29EB8F5FFFD9"

	$pic1 &= "FFD8FFE000104A46494600010101006000600000FFDB004300010101010101010101010101010101010101"
	$pic1 &= "0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010"
	$pic1 &= "1FFDB00430101010101010101010101010101010101010101010101010101010101010101010101010101010101"
	$pic1 &= "010101010101010101010101010101010101010101010101FFC0001108001F002403012200021101031101FFC40"
	$pic1 &= "01B000002010500000000000000000000000000090A0304050608FFC4002F100000060005020404070000000000"
	$pic1 &= "000001020304050600070811214161131451F03171B1D10912165281C1F1FFC4001501010100000000000000000"
	$pic1 &= "000000000000506FFC40020110003010101000202030000000000000001020304050600130711121421FFDA000C"
	$pic1 &= "03010002110311003F009FC631EEE4106A03F9CE52EDD44438E43BFBE30483AF2C81CC1F10288F5F4DFE9DF097F"
	$pic1 &= "589F8803FCB8CFEA7E9B28411EDAD2FE0D85F3326EB3908F6D10D97B409492978588559D4E36D34D90B55926A56"
	$pic1 &= "1DE079146C916941C520496764922BC6ACC41F4BE978DE478FA7B9DDD6B8F9F99A126A37E8B3DF55933E684C12A"
	$pic1 &= "A696B51114BB24A609ADA928A5288AF1B8BD1EFF423CCE5C0E8D765AB841FE059426D6B55C804849CD198850CEE"
	$pic1 &= "4049A3D19119C612C2C8EA010162EFBFEE01F9F1B8FF0078CEA0E137050310C03BF3C087DC711DBBA6B5733E955"
	$pic1 &= "69CB555F3568998F3D0861771F467990973CBD6D6541A3D29DDC59EF2E73F6D4DAAAED58A031939671589F459BB"
	$pic1 &= "030A90EF5112130D4F48BA99AE6A57276819C150178480BD42232AD5AC81013908D7292CBC7CB43C8108651207F"
	$pic1 &= "0B2ECDFC4BD16EAAADCEE99AA76EB2A80A6A182F23F91FCB7B6D5B70F1368A6EE7C21AF4E46AE2BD064D14A4A5A"
	$pic1 &= "16DCFD7BB2329B49E6F2FEC0D313F5BDA13968CD4B27DFF1FDCF370CDABA598A65D75AE78E859E9921D1144A3C5"
	$pic1 &= "935E7CB70DF5BABA3FD46341FCD6747795967DB1831452540E994C3C6E1BF5C18BBF92FF2DA41A83940E51E7728"
	$pic1 &= "FD07B0F1EFAE1326B1344BFAE73B2BBA84A623187B8B2AEB2A35DAB930E5C43445FA931B2F273510CCF638C869B"
	$pic1 &= "96ADCC42C94BC92E949B28A9119660B843BC23749064F1A3AA10DF81C6BF2700D24807C54CA7DFD439E9DC03DF7"
	$pic1 &= "C05E93CD71BD6F23470FBD8D76F3B4BE7ABC59990ADF25E7A735A6E841578DE48E01FDCE8A1A564A46949BA9C6E"
	$pic1 &= "CF4781D0974F95A1B36C8AD66B4003069DE4F1B4DD58105692765247E99090F364A2A3AC78A5B4C398B6E8D7F5A"
	$pic1 &= "6196997B46752C73354ADE9E67DD6EAAC120E1D90147C4A94965B579858966EC4C64CB12F27621ABC5045155FB7"
	$pic1 &= "44DE211B569374F756C80CA9A5E57531A2ECEB74E8A247B02BA391576E1455C2EFE4645EAA44D148EFE5A51E3D9"
	$pic1 &= "37C64106ED85DBB5BCAB66EDFC3413E914687149AC0A15BA6021B0F050E3610F51ED8DD19B1459A652265028000"
	$pic1 &= "6C001B6DFE7DBA604F29F8EFCA78CD3B36F0B9CB0DBBA12CBA35B090A365851EB3CE890942089F6BB528EB116BB"
	$pic1 &= "098BD6890CEB24BBDEBBBBE8E39F37536357365AD2F1802E505E88B37AB355EB566FAD0222B50CE40B9922356C6"
	$pic1 &= "9709A405214BC86C1F0FE7E5EFB60C56C18B8F933F3FFD9"

	$pic2 &= "FFD8FFE000104A46494600010101006000600000FFDB004300010101010101010101010101010101010101"
	$pic2 &= "0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010"
	$pic2 &= "1FFDB00430101010101010101010101010101010101010101010101010101010101010101010101010101010101"
	$pic2 &= "010101010101010101010101010101010101010101010101FFC0001108002A002403012200021101031101FFC40"
	$pic2 &= "01C000003000203010000000000000000000000070A030804050609FFC400351000000601020206070901000000"
	$pic2 &= "0000000102030405060700110821121331415161141516718191F0091723324282A1C1F1E1FFC40019010002030"
	$pic2 &= "1000000000000000000000000000703040608FFC400231100020202010500030100000000000000010302040506"
	$pic2 &= "11000712131408152122FFDA000C03010002110311003F00BF711000DC7B349CBD67AC3F8E67A22AB78CA58EE9F"
	$pic2 &= "68B091152BF5BB45D6B55F9E9C4DC3B33040F0F0F2D26CE464C8BBE21D9A2766D962AAEC876E9899528901813F2"
	$pic2 &= "9E82D5550076E8947F80111EEF2EED46CDBEDD90EE7C407DA4B54B4D967859647CE96AA4CDB0925D3328F71D434"
	$pic2 &= "4C6C6D1629B24E5317884147D71363EA951A2A8A654952A8D448A0194155F76BB963B6182A198FD54F2D2BF9418"
	$pic2 &= "E8220D091097C56EE03E5200193A55635A3CCE013174ED70F35C54B1B9D0B4C3BB64EDE3FEE8D015697D9264965"
	$pic2 &= "9E40DAAF58FF0724058797102322C2B8A3950697A6B360F88AC3B61B9C863B83CA58F662FD127749CB5222EE95B"
	$pic2 &= "90B7459D818857C591ADB4935A65919909C80ECAE99242D84E505808221A79B5749BA4C0E4300EE003DBCF9FD76"
	$pic2 &= "FFBA8729B99C8D8BE9BC2153EB569B039FBA8E22B11CB553AB7482D2A4939ABCC432B3AE2221EB1922585849CA3"
	$pic2 &= "29C23851CB67D1CF1F26F515DAAA74F5659896D9ED1433475D2130A8910C3BEE3C84A6EDF97F1CB50768BBA50EE"
	$pic2 &= "9E2B2F918E21B88962B229A334B1A1DE66C63EB5FE04801C941B06BCA7FE43C2E363D55FDA6BAA5DFF48968F7A8"
	$pic2 &= "5339086405EA6DB31641657E2156DD5792093C06850708FF007D46724F9BBD7EE63AF468D1A6DF581EBC2DC5329"
	$pic2 &= "982E03B07E19B9F2F037C0751BF92ED2AE5CE3B78A6BDB6482B71D8EED28E06242B204520B138C7691D27F72B0B"
	$pic2 &= "84CA4192917EF5FBC8F8F3AA91158EAF4544C675AE41B82C364B6C6AB2EC5721004444860000F70EDFA7539B9B3"
	$pic2 &= "81D95A2DEF886B3D062616591E20ECAFEEAEE527A627584CE37B7CD3568D676560E363E2E4636DED5DBB4179A6B"
	$pic2 &= "1B24FAB446CBAE68E55CB96C22EB489FC82D4B6ADD34EA385D5AB42EB3F7B56E642B49B5D12657A95ADB6B78B6C"
	$pic2 &= "11E1137C555C8AE40C7DB19BF8A91B338343B4F9FC1EB7B15AC8E6DE6B43F56FAF55E16D68836C3EBC1DCAD5C89"
	$pic2 &= "1F90BE604C1044251572F92632F96394A61D51B2970F7947D2065A162B25D76AAFABABF56B3316D7D76DAA61608"
	$pic2 &= "D2980BD1998434A11F3050EA001C9E92D84532AC5591B07E1A8A03538EDF96ED92E7FB4C1B7D77EA6BEB9C1FD9A"
	$pic2 &= "DB5FC4B8CEE15E60B33C6D77AEDB6432192C134EECD7AF64E5994B4245BFAC2B0ACE26BA9ACF1048651F339F975"
	$pic2 &= "0ED9B1906CDD35DF9DEB3A69C0706EE22B6C10705314C54132880F70814DCFB007FE6A97E3B69BB7691AC66F15B"
	$pic2 &= "5D35D02FCEFDD8FAD0721E407E368C2FC8B526529C45D5312B93246330933AFCD592673B3DDDD8B01B366B197F0"
	$pic2 &= "5627682B17F2DB7496D502556EC9AA02D8008C8D69C1931102512C11770F0C843657468D1AE83E94DD615D022C4"
	$pic2 &= "12980077010FEBE7FE0F92B2D340613206EB5B90FBEFF98BF1F7E9B3AC6A0072E5E3FD68E8EB5BA3F0E45347445"
	$pic2 &= "8AD13288180DB81037DC0407C7CBB7C83BF4F883894A31B1122140BD12800000767210E5F5E1CB71DF5DA6C1E01"
	$pic2 &= "F20D7274747468D1A347475FFFD9"

	$pic3 &= "FFD8FFE000104A46494600010101004B004B0000FFDB0043000101010101010101010101010101010101010"
	$pic3 &= "1010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101"
	$pic3 &= "FFDB004301010101010101010101010101010101010101010101010101010101010101010101010101010101010"
	$pic3 &= "10101010101010101010101010101010101010101010101FFC00011080027002203012200021101031101FFC400"
	$pic3 &= "1B0000020203010000000000000000000000000A040802070905FFC400301000010402020101050607000000000"
	$pic3 &= "0000301020405060700110831091213214115516191D1F0141922425271B1FFC400190100020301000000000000"
	$pic3 &= "000000000000020700040805FFC4002311000300020006030101000000000000000102030405000607111213142"
	$pic3 &= "1310815FFDA000C03010002110311003F007EA9D3850C4E211C8DE9157B55EBF2FC7FE72B36D1F253586AC08256"
	$pic3 &= "7BB030EC2224C3123439796E4D4D8DC6992068C578229EE65C3148331AF639E30BDE46A39AAADF9A2F3C8F2FF75"
	$pic3 &= "42D0BA2F6BEDCB41BA4D7EB7C0F29CC6443191445B1763F4D36C415802AA3D0722CE4C70C08EF5639AD3491ABBF"
	$pic3 &= "A78B0BE386D0DC53C63DC998E431CDBD3673897B799A2418B22CEB2059387269B04C7A45992544C670EC5D8F206"
	$pic3 &= "B2054B627C8D2A6D89AC4E4F8A24FF55BABBAEE990D362D306BB2DA6F29738F8D37555C6C3C5334BE6D15993DE4"
	$pic3 &= "56D18C314571FDEECFE5930083CD83C8BC8199CE9FE8DD32678785AC590AD5C126D916F369632101BD40CE74A52"
	$pic3 &= "E675F5AAAF68D3C8F8B3CEB1F293556CE7CA5C0F636139B32010639EEC4B2AA3C8D909E54EC4D98EA69B31B19C4"
	$pic3 &= "E97E1B4CAC57FBAE56A2F4A89696AAE23D9098F0BDAF4544E9517EF4ED3EEFA7146FC89D95B8AD2249B2B0C8C95"
	$pic3 &= "BB8F592C9B1C4B3F1D5D543CDB16B3AB543CEA23DB438A2359505B20015F926397A39D4D715126640915E471072"
	$pic3 &= "637723D9D1E464BF24FC7CD57B6A5461D74CCDB13ADB4B5AD03C8F8B5D7A36120DFC286F33DE624189770E78211"
	$pic3 &= "4CBF18B1061219108E722074B7AC1ACEA4E4EEB573C1C9D76D74698D7BC6E8106462E4B5222E26296F8B696546D"
	$pic3 &= "1B629C8C90886145C9A35692C72E77E9F66F27475B9CF931CCC1D9B5A72A498B195E2A95F597293179D2159D277"
	$pic3 &= "128F930AA18A844A57A6DC398A393A4F9A7A27D53871C7C2F38A93E566A3C7B74EA1D83ABF308A7998B67B8A5D6"
	$pic3 &= "2D7A08A548F296BEE204886634390AC2B634E8C844910A4A88A80962095464F7158AAF1B9ED2360399E37E119B5"
	$pic3 &= "FE03903226B7ABCBB2AD966A9B8816733136DE5B50D7D1AE3EFC8E7D6ADF5E92825FDA37452C9891EAE29628687"
	$pic3 &= "E3DD027D2386E6509B2AAE4355BDAB84F4F44FF17275F8AFCFD78ACFE5C69DCEE47B4A31EBCACA9145A4CA3C6B8"
	$pic3 &= "B4941793DF02055CEBDC5F3ACEECF25A86CAB078231ECABEAF23A09CF09084286259088256B5C46F33B7F4972EE"
	$pic3 &= "16C391323733D58CBDEE1D7074F879728D2F930D76F36D818DB082495C49FDFE3259D2A8CF8F53E58D48D28CCCD"
	$pic3 &= "EE8DEDF27139A25AE7CEF8FACC89E56C3231DE8928D72F5983936C4A3395F35F5F772E88EAB541DACB4440A2B7E"
	$pic3 &= "50D6D8541F06C3051AD763E5719F518C61F04A20D81CB60D513EC25006D5656D256893F89B6B79034875B106A42"
	$pic3 &= "BDA37098561EF676E851F8F9A2B5B6AC8877CC0E198CD7D51E7BD8E67DA164AD24BB8B160D555C21D85B499D304"
	$pic3 &= "17ABDC119DA2790AE62BDDC62F1834966FFCC6AF6DEDEAE34CA5C7FC70914D75715A6AF9D0205EE479D60F698ED"
	$pic3 &= "51E4D6BCD1C13675563D904C6C76910858F050A66BBDC17B8D11AFA819555D1D8D1FB9D31BFDBD7A22A7A27FB5F"
	$pic3 &= "5FD79C7FE61E47C5D272CE77365E5932DCEFB27275558DE3F1E789AFD1EC7331A529C8B3B35AF922D5CAB338525"
	$pic3 &= "2309CA7E877B5FEB5F335B65B9C5D0C9E2FAED5C219C94953DCD7CBDA61E35A8EF40142CE51F5A42617C879528E"
	$pic3 &= "EDED5496CE4637A4F97D13EABFAF0E67C39A87849711A5476C91386E4ED1C8A9F9FEFF007D2734666FA5F18CC47"
	$pic3 &= "F02EAAEBAC80D38E48C33E2479426480AAA84EC1C81118C3895CAA32B511EC572AB5C8BC38705D1288D3A22D26E"
	$pic3 &= "A55D1D4323A91D8AB2B021948FA208208FDE09599183A332B2905594956523EC104762083F841EE388382E8DC5B"
	$pic3 &= "0C7B929AAEBEBC4F31243C3063478A279CBD298EF18063638A5722388556ABDEBD2B9CAA88BCB03162B228DA362"
	$pic3 &= "227489C38722224D1673459CD142A2228544503B05555002A81F4000001F9C4666762EECCCCC49666259989FB24"
	$pic3 &= "93DC924FE927B9E24F0E1C385C0F1FFD9"
	FileWrite(@TempDir & "\chip.jpg", Binary($pic))
	FileWrite(@TempDir & "\1.jpg", Binary($pic1))
	FileWrite(@TempDir & "\2.jpg", Binary($pic2))
	FileWrite(@TempDir & "\3.jpg", Binary($pic3))
EndFunc